// provides a class to store global statistics (mainly used in webif)
#ifndef __STATS_H__
#define __STATS_H__

#ifdef WIN32
#else
#include <strings.h>
#endif

#include "common.h"

class webif_console_line
{
public:
	webif_console_line(char *init_line, webif_console_line *init_previous, webif_console_line *init_next);
	~webif_console_line( void );
	
	char *line;
	webif_console_line *previous;
	webif_console_line *next;
};

class statistics
{
public:
	statistics( void );
	~statistics( void );
	
	char started_on[32];
	
	// ---------------------------------- cardserver client ---------------------------------
	void cs_connected( void );
	char cs_last_connection_time[32];
	
	unsigned int cs_reconnections;
	
	unsigned int cs_successful_ecms;
	unsigned int cs_ecm_failures;
	
	unsigned int cs_successful_emm_g;
	unsigned int cs_emm_g_failures;

	unsigned int cs_successful_emm_s;
	unsigned int cs_emm_s_failures;

	unsigned int cs_successful_emm_u;
	unsigned int cs_emm_u_failures;
	
	// ---------------------------------------- webif console ---------------------------------------
	// this buffer is a doubly linked list of dinamically allocated strings (webif_console_line class).
	// it is mantained at a maximum length of webif_console_line::webif_buffer_length_max
	webif_console_line *webif_console_line_root;
	
	int webif_console_line_buffer_length;
	int webif_console_line_buffer_length_max;
	
	void webif_console_add_line(char *line);
	void webif_console_add_text(char *text);
	
	// ------------------------------------------ nagra 2 -------------------------------------------
	unsigned char n2_ecm_rsa_decryption_key[64];
	unsigned char n2_ecm_idea_decryption_key[16];
	
	unsigned char n2_mecm_select;
	unsigned char n2_mecm_idea_decrypt_key[16];
	unsigned char n2_mecm_encrypted[256];
	unsigned char n2_mecm_decrypted_before_execution[256];
	unsigned char n2_mecm_hw_before_execution[128];
	unsigned char n2_mecm_decrypted_after_execution[256];
	unsigned char n2_mecm_hw_after_execution[128];
	unsigned int n2_mecm_execution_time;
	unsigned int n2_mecm_instruction_count;
	char n2_mecm_execution_summary[4096];
	char n2_mecm_execution_status[16];
	
	bool n2_emm_is_valid;
	unsigned char n2_emm_before_b1_nano_execution[96];
	unsigned char n2_emm_rsa_decryption_key[96];
	unsigned char n2_emm_idea_decryption_key[24];
	unsigned char n2_emm_b1_nano[96];
	unsigned int n2_emm_b1_nano_length;
	unsigned int n2_emm_b1_nano_execution_time;
	unsigned int n2_emm_b1_nano_instruction_count;
	char n2_emm_b1_nano_execution_summary[4096];
	char n2_emm_b1_nano_execution_status[16];
	char n2_emm_parsing_status[4096];
	unsigned char n2_emm_after_b1_nano_execution[96];
};

#endif
